<template>
    <span class="dynamic_control" @focus.capture="(evt) => $emit('focus', evt)">
        <el-select v-if="isSelect" v-model="currentValue" filterable :multiple="isMultiple" :style="style"
            :class="validationClasses" :placeholder="'Select option'">
            <el-option v-for="item in dictionary" :key="item.value" :label="item.label" :value="item.value">
            </el-option>
        </el-select>
        <el-checkbox v-else-if="isCheckbox"
                v-model="currentValue"
                active-color="#13ce66"
                inactive-color="#ff4949"
                :class="validationClasses"
            >
        </el-checkbox>
        <el-date-picker v-else-if="isDatepicker"
            v-model="currentValue"
            :type="type"
            :value-format="dateFormat"
            :style="style"
            :class="validationClasses"
            :placeholder="placeholder">
        </el-date-picker>
        <video-link-editor v-else-if="isVideoLinkEditor"
            v-model="currentValue"
            :popupTitle="config.popupTitle"
            :input-style="style"
            :class="validationClasses"
        />
        <rich-text-editor v-else-if="isRichTextEditor" v-model="currentValue" :style="style" :class="validationClasses" />
        <el-input v-else
            :type="type"
            :rows="textareaRows"
            :autosize="textareaAutosize"
            :placeholder="placeholder"
            :style="style"
            :class="validationClasses"
            v-model="currentValue">
                <template v-if="isDomain" v-slot:prepend>http(s)://</template>
        </el-input>
        <validation-box :message="invalidMsg" :is-invalid="isInvalid" />
    </span>
</template>

<script>
import { ControlTypes } from '@/constants/ui/details';
import { VideoLinkEditor } from '@/components/MediaURLEditor';
import ValidationBox from '@bloomio/spa-admin-common/components/validation-box';
import RichTextEditor from '@/components/RichTextEditor';
import { debounce } from '@/utils';

let debouncedCheck = null; // delayed function to async validate value of the parameter

export default {
    components: {
        VideoLinkEditor,
        RichTextEditor,
        ValidationBox,
    },
    props: {
        /** control settings */
        config: {
            type: Object,
            required: false,
            default: () => {},
        },
        /** edit param id */
        id: {
            type: String,
            required: true,
        },
        /** reset value */
        initValue: {
            type: null,
            required: false,
        },
        /** current value */
        value: {
            type: null,
            required: false,
        },
        /** max width of the control */
        maxWidth: {
            type: String,
            required: false,
            default: '30rem',
        },
        /** min width of the control */
        minWidth: {
            type: String,
            required: false,
            default: '30rem',
        },
        /** validation flag */
        isInvalid: {
            type: Boolean,
            required: false,
            default: false,
        },
        /** validation messages */
        invalidMsg: {
            type: [String, Array],
            required: false,
            default: '',
        },
    },
    created() {
        if (this.value !== this.initValue) {
            this.validate(this.value);
        }
    },
    beforeDestroy() {
        debouncedCheck = null;
    },
    computed: {
        currentValue: {
            get() {
                return this.value;
            },
            set(newVal) {
                this.$emit('input', newVal);
                this.validate(newVal);
            },
        },
        type: vm => vm.config.type,
        style: vm => ({ minWidth: vm.minWidth, maxWidth: vm.maxWidth, width: '100%' }),
        isDomain: vm => vm.type === ControlTypes.DOMAIN || vm.config.subtype === ControlTypes.DOMAIN,
        isSelect: vm => vm.type === ControlTypes.SELECT || vm.type === ControlTypes.MULTISELECT,
        isMultiple: vm => vm.type === ControlTypes.MULTISELECT,
        isCheckbox: vm => vm.type === ControlTypes.CHECKBOX,
        isDatepicker: vm => vm.type === ControlTypes.DATEPICKER,
        isVideoLinkEditor: vm => vm.type === ControlTypes.VIDEO_URL_WITH_WATCHER,
        isRichTextEditor: vm => vm.type === ControlTypes.RICH_TEXT_EDITOR,
        textareaRows: vm => (vm.config.rows ? vm.config.rows : 2),
        textareaAutosize: vm => (vm.config.autosize ? vm.config.autosize : false),
        placeholder: vm => (vm.config.placeholder ? vm.config.placeholder : 'Enter value...'),
        dateFormat: vm => (vm.config.format ? vm.config.format : 'yyyy-MM-dd'),
        dictionary: vm => (vm.config.dictionaryArray || vm.$store.getters.dictionaryArray(vm.id)),
        validationClasses: vm => ({ invalid: vm.isInvalid }),
    },
    methods: {
        /**
         * Validate method for the assosiated parameter
         * @param {any} val - current value of the parameter in the control
         */
        validate(val) {
            if (this.config.inputAction) {
                const {
                    name, routeParams, data, required, blockSubmit,
                } = this.config.inputAction;
                // update parameter value for API request
                if (routeParams && Object.prototype.hasOwnProperty.call(routeParams, this.id)) {
                    routeParams[this.id] = val;
                }
                if (data && Object.prototype.hasOwnProperty.call(data, this.id)) {
                    data[this.id] = val;
                }
                if (blockSubmit) { // block submit button before getting server response
                    this.$emit('validated', {
                        invalid: this.isInvalid, id: this.id, message: this.invalidMsg, value: val, blocked: true,
                    });
                }
                if (!required || val) {
                    if (!debouncedCheck) {
                        debouncedCheck = debounce(this.sendValidationRequest, 600);
                    }
                    debouncedCheck(name, routeParams, data);
                }
            }
        },
        /**
         * Send request to validate parameter: only for the parameters that have unique api route for the validation
         * @param {String} name - API route name
         * @param {Object} routeParams - dynamic parameters for the api route
         * @param {*} payload - body for the request
         */
        sendValidationRequest(name, routeParams = null, payload = null) {
            this.$store.dispatch(name, { params: routeParams, data: payload }).then(({ invalid, message }) => {
                this.$emit('validated', {
                    invalid, message, id: this.id, value: this.currentValue, blocked: invalid,
                });
            });
        },
    },
};
</script>

<style lang="stylus" scoped>
.dynamic_control
    width: 100%
    display: flex
    flex-direction: column

.invalid >>> .el-input__inner,
.invalid:focus >>> .el-input__inner
    border-color: $base_red !important

</style>
